﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private CartBitmap As B4XBitmap
	Private IconCanvas As B4XCanvas
	Private BadgeNumber As Int
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Dim cs As CSBuilder
	Dim rp As RuntimePermissions
	
	cs.Initialize.Color(Colors.Black).Size(16).Append("Menu Icons").PopAll
	
	Root = Root1
	'B4XPages.SetTitle(Me, "Menu Icons")
	B4XPages.SetTitle(Me, cs)
	Root.LoadLayout("MainPage")
	
	'CartBitmap = xui.LoadBitmap(File.DirAssets, "cart.png")
	CartBitmap = TextToB4XBitmap(Chr(0xE854),18,Colors.Black,18,18,Typeface.MATERIALICONS,"CENTER")
		
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 28dip, 28dip)
	IconCanvas.Initialize(p)
	
	UpdateMenuItems
	
	rp.CheckAndRequest(rp.PERMISSION_WRITE_EXTERNAL_STORAGE)
	Wait For Activity_PermissionResult(Permission As String, bResult As Boolean)
			
	rp.CheckAndRequest(rp.PERMISSION_READ_EXTERNAL_STORAGE)
	Wait For Activity_PermissionResult(Permission As String, bResult As Boolean)
	
End Sub

Sub TextToB4XBitmap(strText As String, fFontSize As Float, iFontColour As Int, _
				 	iWidth As Int, iHeight As Int, _
				 	TF As Typeface, strAlignment As String) As B4XBitmap
 
	Dim bmp As Bitmap
	Dim cvs As Canvas
	 
	bmp.InitializeMutable(iWidth * 100dip / 100, iHeight * 100dip / 100)
	cvs.Initialize2(bmp)
	Dim h As Double = cvs.MeasureStringHeight(strText, TF, fFontSize)
	cvs.DrawText(strText, bmp.Width / 2, bmp.Height / 2 + h / 2, TF, fFontSize, iFontColour, strAlignment)
	 
	Return bmp.As(B4XBitmap)
 
End Sub

Private Sub UpdateMenuItems
	
	Dim bmp As B4XBitmap = CreateIconWithBadge(CartBitmap, BadgeNumber)
	#if B4A
	Dim menus As List = B4XPages.GetManager.GetPageInfoFromRoot(Root).Parent.MenuItems
	menus.Clear
	
	'add menu items
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "cart")
	mi.AddToBar = True
	mi.Bitmap = bmp
	
	Dim b4xbmp As B4XBitmap = TextToB4XBitmap(Chr(0xE003),28,Colors.Black,28,28,Typeface.MATERIALICONS,"CENTER")
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "setup")
	mi.AddToBar = True
	mi.Bitmap = b4xbmp
	
	Dim b4xbmp As B4XBitmap = TextToB4XBitmap(Chr(0xE8B8),28,Colors.Black,28,28,Typeface.MATERIALICONS,"CENTER")
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "setup")
	mi.AddToBar = True
	mi.Bitmap = b4xbmp
	

	
	Dim b4xbmp As B4XBitmap = TextToB4XBitmap(Chr(0xF142),28,Colors.Black,28,28,Typeface.FONTAWESOME,"CENTER")
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "hamburger")
	mi.AddToBar = True
	mi.Bitmap = b4xbmp
	
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	ctxt.RunMethod("invalidateOptionsMenu", Null)
	
	#else if B4i
	Dim bb As BarButton
	bb.InitializeBitmap(Main.KeepOriginalColors(bmp), "cart")
	B4XPages.GetNativeParent(Me).TopRightButtons = Array(bb)
	#end if
	
End Sub

Private Sub CreateIconWithBadge(bmp As B4XBitmap, Number As Int) As B4XBitmap
	
	IconCanvas.ClearRect(IconCanvas.TargetRect)
	IconCanvas.DrawBitmap(bmp, IconCanvas.TargetRect)

	If Number > 0 Then
		Dim cx As Int = IconCanvas.TargetRect.Width - 8dip
		Dim cy As Int = 8dip
		IconCanvas.DrawCircle(cx, cy, cy, Colors.Red, True, 0)
		Dim fnt As B4XFont = xui.CreateDefaultBoldFont(12)
		Dim r As B4XRect = IconCanvas.MeasureText(Number, fnt)
		Dim BaseLine As Int = cy - r.Height / 2 - r.Top
		IconCanvas.DrawText(Number, cx, BaseLine, fnt, xui.Color_White, "CENTER")
	End If
	
	Return IconCanvas.CreateBitmap
	
End Sub

Private Sub btnIncrement_Click
	If BadgeNumber < 9 Then
		BadgeNumber = BadgeNumber + 1
		UpdateMenuItems
	End If
End Sub

Private Sub btnClear_Click
	BadgeNumber = 0
	UpdateMenuItems
End Sub

Private Sub B4XPage_MenuClick (Tag As String)
	Log(Tag)
End Sub

Sub btnScreenShot_Click

	Dim bmp As Bitmap
	bmp = TakeScreenshot
	SaveBitmap(bmp, "Menu.png")

End Sub

Sub SaveBitmap(bmp As Bitmap, strFile As String)
	
	Dim Out As OutputStream
	
	Out = File.OpenOutput(File.DirRootExternal & "/PhonePats/", strFile, False)
	bmp.WriteToStream(Out, 100, "PNG")
	Out.Close
	
End Sub

Sub TakeScreenshot As Bitmap
	
	Dim jo As JavaObject
	
	jo.InitializeContext
	
	Dim decor As JavaObject = jo.RunMethodJO("getWindow", Null).RunMethod("getDecorView", Null)
	Dim decorChild As JavaObject = decor.RunMethod("getChildAt", Array(0))
	
	decorChild.RunMethod("setDrawingCacheEnabled", Array(True))
	decorChild.RunMethod("buildDrawingCache", Null)
	
	Dim bmp As Bitmap = decorChild.RunMethod("getDrawingCache", Array(True))
	
	bmp.Initialize3(bmp)
	decorChild.RunMethod("setDrawingCacheEnabled", Array(False))
	Return bmp
	
End Sub